CON

'5MHz crystal
  _clkmode = xtal1 + pll8x 
  _xinfreq = 5_000_000

{
'10MHz crystal
  _clkmode = xtal1 + pll4x
  _xinfreq = 10_000_000
}
' Choose parameters for sht31.init(scl, sda, dev_id, mode)
  SCL=8     ' sda and scl need pullups, open drain.  scl used for clock hold mechanism
  SDA=9
  DEV_ID = sht31#DEV_ID44  '  options re sht31#DEV_ID44 or sht31#DEV_ID45
  MODE = sht31#HOLD_MEDIUM  '  options are sht31#HOLD_HIGH, sht31#HOLD_MEDIUM, sht31#HOLD_LOW
'     corresponding to accuracy/speed:  0.1%/12ms,   0.15%/4ms,  0.25%/2ms
 

OBJ
    uarts   : "fullDuplexSerial4pnf"   'Debug terminal for communication
    i2cx    : "i2c_1bus"
    sht31   : "sht31_1bus"
   
VAR
   long lock

PUB Main | char, devID
  Startuarts  ' for debug only
  InitSht31

  repeat
    sht31.acquireData                      ' captures current degC and RH
    uarts.str(0,string("degC="))
    uarts.decp(0, sht31.temperature, 2)
    uarts.str(0,string("   RH="))
    uarts.decp(0, sht31.humidity, 1)
    uarts.tx(0,13)
    pause(1000)
    if (char := uarts.rxCheck(0)) == "1"    ' for demo, play with the heater
      sht31.Control(sht31#HEATER_ON)
      uarts.str(0,string(13,"heater on",13))
    elseif char == "0"
      sht31.Control(sht31#HEATER_OFF)
      uarts.str(0,string(13,"heater off",13))

PUB InitSht31
  if sht31.init(SCL,SDA, DEV_ID, MODE) <> 6  ' choose settings and test for buss pullups and sht31 present
    uarts.str(0,string(13,"device not found  pullups="))
    uarts.bin(0,ina[14..13],2)
    uarts.str(0,string(" ack="))
    uarts.dec(0, sht31.Hello)
    uarts.Tx (0,13)
  else
    uarts.str(0,string(13,"i2c pullups and Ack okay"))
    uarts.str(0,string(13,"you can press 1 or 0 to turn the SHT31 heater on or off...",13))
  
PUB StartUarts
    uarts.Init
    uarts.AddPort (0,31,30,0,115200)
    uarts.start

PUB Pause(ms)
    waitcnt(clkfreq/1000*ms+cnt)